﻿using System;
using System.Windows;
using Infragistics.Windows.DataPresenter;
using System.Collections.Generic;
using System.Windows.Data;
using System.Windows.Controls;
using System.Drawing;
using System.Globalization;
namespace WPF_XamDataGrid_GroupByEvaluator
{
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            //xamDataGrid1.DataSource = new List<Data2>
            //{
            //    new Data2 { ID = 3.345, Abbreviation = "z" },
            //    new Data2 { ID = 3.245, Abbreviation = "a" },
            //    new Data2 { ID = 3.145, Abbreviation = "a" },
            //    new Data2 { ID = 30.145, Abbreviation = "a30" },
            //    new Data2 { ID = 1.145, Abbreviation = "b"},
            //    new Data2 { ID = 10.145, Abbreviation = "b10"},
            //    new Data2 { ID = 5.145, Abbreviation = "3v"},
            //    new Data2 { ID = 50.145, Abbreviation = "3v50"},
            //    new Data2 { ID = 2.145, Abbreviation = "c"},
            //    new Data2 { ID = 20.145, Abbreviation = "c20"},
            //};

            List<Data2> gdSource = new List<Data2>();
            for (int cnt1 = 0; cnt1 <= 1; cnt1++)
            {
                for (int cnt2 = 0; cnt2 <= 0; cnt2++)
                {
                    gdSource.Add(new Data2 { ID = 1.1234 * cnt1 * cnt2, Abbreviation = "This is column is for Abbreviation of Z" + cnt1.ToString(), IDName = "This is ID colum with the following value N" + (2 * cnt1 * cnt2).ToString() });
                }
            }
            xamDataGrid1.DataSource = gdSource;
        }


        private void xamDataGrid1_Grouped(object sender, Infragistics.Windows.DataPresenter.Events.GroupedEventArgs e)
        {
            foreach (var item in xamDataGrid1.Records)
            {
                string[] text1 = item.Description.Split(new char[] { '(' });

                item.Description = "";
                if (text1.Length > 2)
                {
                    item.Description += text1[0];
                    for (int i = 1; i < text1.Length - 1; i++)
                    {
                        item.Description += "(" + text1[i];
                    }

                }
                else
                    item.Description = text1[0];
            }
        }
        //void OnColumnSizeChanged(object sender, SizeChangedEventArgs e)
        //{
        //    foreach (var item in xamDataGrid1.Records)
        //    {
        //        GroupByRecord dr = item as GroupByRecord;
        //        if (dr != null)
        //        {
        //            item.Description = GetFitText(item.Tag.ToString(), dr.GroupByField.LabelWidthResolved+10);  // additional 10 for group by indent space
        //        }
        //    }

        //}
        public string GetFitText(string strActualtext, double dblAvailablewidth) 
        {
            if ((strActualtext.Length<=0) || (dblAvailablewidth <= 0))         
                return "";

            int intLen = strActualtext.Length;     
            
            string strResult;      
            
            while(true)
            {
                strResult = strActualtext.Substring(0, intLen);
                System.Windows.Media.FormattedText objFrmtText = new System.Windows.Media.FormattedText(strResult,
                                                       CultureInfo.GetCultureInfo("en-us"),                                                          
                                                       FlowDirection.LeftToRight,
                                                       new System.Windows.Media.Typeface(xamDataGrid1.FontFamily.Source),
                                                       xamDataGrid1.FontSize,
                                                       System.Windows.Media.Brushes.Black);
                objFrmtText.SetFontWeight(FontWeights.Bold);

                if (objFrmtText.Width <= dblAvailablewidth)             
                    break;         
                else
                    intLen--;     
            }
            if (strActualtext != strResult)
            {
                strResult += "...";
            }
            return strResult; 
        }

        bool bWidthFound = false;
        double dblGrpColWidth = 0;
        void OnColumnSizeChanged(object sender, SizeChangedEventArgs e)
        {

            bWidthFound = false;
            foreach (Record item in xamDataGrid1.Records)
            {

                // Truncate the labels on GroupBy records

                TruncateGroupByLabels(item);

                // In case the GroupBy records have nested GroupBy records

                if (item.HasChildren)
                {

                    GetChildGroupByRecords(item);

                }

            }

        }



        // Execute recursively to retrieve all GroupBy records and set the labels

        public void GetChildGroupByRecords(Record record)
        {

            foreach (Record rec in record.ViewableChildRecords)
            {

                if (rec.HasChildren)
                {

                    GetChildGroupByRecords(rec);

                }

                TruncateGroupByLabels(rec);

            }

        }



        public void TruncateGroupByLabels(Record item)
        {

            GroupByRecord dr = item as GroupByRecord;

            if (dr != null)
            {
                if (!(bWidthFound))
                {
                    bWidthFound = true;
                    dblGrpColWidth = dr.GroupByField.LabelWidthResolved;
                }

                item.Description = GetFitText(dr.Value.ToString(), dblGrpColWidth + 10);  // additional 10 for group by indent space

            }

        }
    }

    public class SummaryTextFormat : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            SummaryResult sr = (value as SummaryResult);
            //string[] tmp = sr.DisplayText.Split(new char[0], Int32.MaxValue, StringSplitOptions.None);

            string strformat = "N1"; // Data.DataSource.dicColFrmts[sr.SourceField.Name];
            if (sr.Value != null)
            {
                return Double.Parse(sr.Value.ToString()).ToString(strformat);
            }
            return Double.Parse("0").ToString(strformat);
            //return sr.Value;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            return Binding.DoNothing;
        }
    }

    public class Data2
    {
        public double ID { get; set; }
        public string Abbreviation { get; set; }
        public string IDName { get; set; }
    }  
}
